package sample.client;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;


/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class MyClient implements EntryPoint {
    private TextBox txtbox = new TextBox();
    private Button btn = new Button("Click me");
    private Label lbl = new Label();
    private AsyncCallback callback = new AsyncCallback() {
            public void onFailure(Throwable caught) {
                lbl.setText(caught.getMessage());
            }

            public void onSuccess(Object result) {
                lbl.setText((String) result);
            }
        };

    private MyServiceAsync getProxy() {
        MyServiceAsync proxy = (MyServiceAsync) GWT.create(MyService.class);
        String address = GWT.getModuleBaseURL() + "myservice.rpc";
        ((ServiceDefTarget) proxy).setServiceEntryPoint(address);

        return proxy;
    }

    public Button getBtn() {
        return btn;
    }

    public Label getLbl() {
        return lbl;
    }

    public TextBox getTxtbox() {
        return txtbox;
    }

    /**
       * This is the entry point method.
       */
    public void onModuleLoad() {
        btn.addClickListener(
            new ClickListener() {
                public void onClick(Widget sender) {
                    getProxy().greeting(txtbox.getText(), callback);
                }
            });
        RootPanel.get().add(getTxtbox());
        RootPanel.get().add(getBtn());
        RootPanel.get().add(getLbl());
    }
}
