package sample.server;

import javax.servlet.http.HttpServletRequest;

import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.google.gwt.user.client.rpc.SerializationException;
import com.google.gwt.user.server.rpc.RPC;
import com.google.gwt.user.server.rpc.RPCRequest;
import com.google.gwt.user.server.rpc.RemoteServiceServlet;

public class DispatcherServlet extends RemoteServiceServlet {

	@Override
	public String processCall(String payload) throws SerializationException {
		ClassPathXmlApplicationContext context = 
			new ClassPathXmlApplicationContext("applicationContext.xml");
		HttpServletRequest httpRequest = getThreadLocalRequest();
		String path = httpRequest.getPathInfo();
		String serviceName = path.substring(path.lastIndexOf('/')+1);
		Object bean = context.getBean(serviceName);
		
		RPCRequest rpcRequest = RPC.decodeRequest(payload, bean.getClass());
		
		return RPC.invokeAndEncodeResponse(bean, rpcRequest.getMethod(), rpcRequest.getParameters());
	}

	
}
